'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ASYNC = undefined;

var _redux = require('./redux');

var ASYNC = exports.ASYNC = Symbol('async middleware');

exports.default = function (store) {
  return function (next) {
    return function (action) {
      if (typeof action[ASYNC] === 'undefined') {
        return next(action);
      }
      var _action$ASYNC = action[ASYNC];
      var key = _action$ASYNC.key;
      var promise = _action$ASYNC.promise;


      if (typeof key !== 'string') {
        throw new Error('Specify a string key.');
      }

      if (!promise) {
        throw new Error('Specify one of the promise');
      }

      next((0, _redux.load)(key));

      return promise(store).then(function (data) {
        return next((0, _redux.loadSuccess)(key, data));
      }).catch(function (error) {
        return next((0, _redux.loadFail)(key, error.toString()));
      });
    };
  };
};